; This small program execute on a CD boot sector
; It print a string and shutdown
; used to test if boot reach CD boot

	org 7c00h

section .text

start:
	jmp   0x0000:boot
	times 8-($-$$) db 0

	;startBoot Information Table
bi_PrimaryVolumeDescriptor  dd  0    ; LBA of the Primary Volume Descriptor
bi_BootFileLocation         dd  0    ; LBA of the Boot File
bi_BootFileLength           dd  0    ; Length of the boot file in bytes
bi_Checksum                 dd  0    ; 32 bit checksum
bi_Reserved                 times 40 db 0   ; Reserved 'for future standardization'

boot:
	; startBoot code here - set segment registers etc...
	; set stack pointer
	xor	ax, ax
	mov	ss, ax
	mov	sp, 0fffeh
	mov	ds, ax
	mov	es, ax

%ifdef COM_LOG
	; initialize com port
	mov	dx, 0
	mov	cx, 0308h
	xor	bx, bx
	mov	ax, 0401h
	int	14h
%endif

	mov	si, string
	cld
loop_char:
	lodsb
	cmp	al, 0
	je	halt
	call	write_char
	jmp	loop_char	


	; terminate, loop waiting characters
halt:
	; try shutdown

	; Connect to APM API
	mov	ax,5301h
	xor	bx,bx
	int	15h

	; Try to set APM version (to 1.2)
	mov	ax,530eh
	xor	bx,bx
	mov	cx,0102h
	int	15h

	;Turn off the system
	mov	ax,5307h
	mov	bx,0001h
	mov	cx,0003h
	int	15h

	xor	ax, ax
	int	16h
	jmp	halt

	; Write a character
	; AL = character
write_char:
	pusha
	mov	ah, 0eh
	mov	bx,7
	int	10h
%ifdef COM_LOG
	mov	ah, 1
	mov	dx, 0
	int	14h
%endif

	popa
	ret

string:
	db	"CDROM CODE CALLED TO SHUTDOWN", 13, 10, 0

	times 2048-($-$$) db 0

;	times 510-($-$$) db 0
;	dw	0aa55h

;	times 2046-($-$$) db 0
;	dw	0aa55h


