; Defines used in this program

; COM_LOG         log to COM
; XEN_LOG         log to XEN port


	; Write a character
	; AL = character
write_char:
	pusha
	mov	ah, 0eh
	mov	bx,7
	int	10h
%ifdef COM_LOG
	mov	ah, 1
	mov	dx, 0
	int	14h
%endif

%ifdef XEN_LOG
	cmp	al, 13
	je	no_xen_log
	out	12h, al
no_xen_log:
%endif
	popa
	ret


	; Write a string (zero terminated)
	; DS:SI string
	; -> DS:SI after NUL char
write_str:
	push	bp
	mov	bp, sp
write_str_save:
	add	bp, 4
	cld
.loop:
	lodsb
	cmp	al, '%'
	jne	.normal
	lodsb
	cmp	al, 'x'
	jne	.normal
	mov	ax, [bp]
	add	bp, 2
	call	write_hex
	jmp	.loop

.normal:
	test	al,al
	jz	.end
	call	write_char
	jmp	.loop
.end:
	pop	bp
	ret


	; Write value in hexadecimal
	; AX = value
write_hex:
	push	cx
	mov	cx, 4
.loop:
	rol	ax, 4
	call	write_hex_char
	loop	.loop
	pop	cx
	ret


write_hex_char:
	push	ax
	and	al, 0fh
	add	al, '0'
	cmp	al, '9'
	jna	.ok
	add	al, 'A' - '0' - 10
.ok:
	call	write_char
	pop	ax
	ret


write_following:
	push	bp
	mov	bp, sp
	push	si
	mov	si, [bp+2]	; return code

	push	ds
	push	cs	; copy CS into DS
	pop	ds

	call	.help
	mov	[bp+2], si
	pop	ds
	pop	si
	pop	bp
	ret
.help:
	push	bp
	mov	bp, sp
	add	bp, 8
	jmp	write_str_save

